import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.geom.*;
import javax.swing.*;


class MousePanel extends JPanel implements MouseMotionListener
{
    ArrayList<Line2> lines;
    Point base, current;
    boolean isDragging;
    
    MousePanel()
    {
	isDragging = false;
	lines = new ArrayList<Line2>();
	addMouseListener(new MouseHandler());
	addMouseMotionListener(this);
    }

    public void paintComponent(Graphics g)
    {
	super.paintComponent(g);

	Graphics2D g2 = (Graphics2D) g;
	for (Line2 line: lines) line.draw(g);
    }

    private class MouseHandler extends MouseAdapter
    {

	public void mousePressed(MouseEvent event)
	{
	    isDragging = true;
	    current = event.getPoint();
	    base = event.getPoint();
	}

	public void mouseReleased(MouseEvent event)
	{
	    isDragging = false;
	    current = event.getPoint();

	    Graphics g = getGraphics();
	    int bx = base.x;
	    int by = base.y;
	    g.setXORMode(Color.WHITE);
	    g.drawLine(bx,by,current.x,current.y);
	    g.setPaintMode();
	    g.setColor(Color.BLACK);
	    lines.add(new Line2(bx,by,current.x,current.y));
	    repaint();
	}
    }

    public void mouseDragged(MouseEvent event)
    {
	Graphics g = getGraphics();
	int bx = base.x;
	int by = base.y;
	g.setXORMode(Color.WHITE);
	g.drawLine(bx,by,current.x,current.y);
	current = event.getPoint();
	g.drawLine(bx,by,current.x,current.y);
	g.setPaintMode();
	g.setColor(Color.BLACK);
    }

    public void mouseMoved(MouseEvent event)
    {
    }
}

public class growline extends JApplet
{
    public void init()
    {
	EventQueue.invokeLater(new Runnable() {
	    public void run()
	    {
		MousePanel panel = new MousePanel();
		add(panel);
	    }
	});
    }
   public static void main(String[] args)
   {
       EventQueue.invokeLater(new Runnable() {
	   public void run()
	   {
	       MousePanel panel = new MousePanel();
	       JFrame frame = new JFrame("Grow Line");
	       frame.add(panel);
	       frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	       frame.setSize(400,400);
	       frame.setVisible(true);
	   }
       });
   }
}
